LRESULT CALLBACK cz_proc_a (HWND hWnd,UINT messg,WPARAM wParam,
 LPARAM lParam)

{
 OPENFILENAME openfilename;
 char init_filename[500];
 char file_filter[]="System Exclusive Files (.syx)\0*.syx\0";
 char def_extend[]=".syx";

 /* The system places the selected file back into the
 init box filename of the OpenFile dialog. If the buffer
 is too small this string never gets replaced with the 
 file and full path. The FileTitle is merely the file
 itself selected. */

 strcpy(init_filename,"syxfile.syx");

 switch (messg) 
 {
  case WM_DESTROY:
   PostQuitMessage(0);
   break;

  case WM_SIZE:
   break;

  case WM_PAINT:
   draw_cz_window();
   break;

  case WM_COMMAND:
   switch (LOWORD(wParam)) 
   {
	case ID_CZ_01:     
     DialogBox(application_inst,"CZ_MIDI_DIALOG",cz_window,
      (DLGPROC)cz_proc_c);
	break;

	case ID_CZ_02:
     status_code=0;
	 error_code=0;
	 draw_cz_window();
	
	 if ((midi_device_in==0)||(midi_device_out==0))
	 {
	  MessageBox(cz_window,"Midi in or out can not be 'none'",
	   "Select legitimate Midi devices please!",
	   MB_APPLMODAL||MB_OK);
	  break;
	 }

     if (cz_test_online()!=1) break;

	 memset(&openfilename,0,sizeof(OPENFILENAME));
	 openfilename.lStructSize=sizeof(OPENFILENAME);
	 openfilename.hwndOwner=cz_window; 
     openfilename.hInstance=application_inst; 
     openfilename.lpstrFilter=file_filter; 
     /* openfilename.lpstrCustomFilter=NULL; */
     /* openfilename.nMaxCustFilter=NULL; */
     openfilename.nFilterIndex=1; 
     openfilename.lpstrFile=init_filename;
     openfilename.nMaxFile=sizeof(init_filename);  
     /* openfilename.lpstrFileTitle=NULL; */
     /* openfilename.nMaxFileTitle=NULL; */ 
     /* openfilename.lpstrInitialDir=NULL; */
     /* openfilename.lpstrTitle=NULL; */
     openfilename.Flags=OFN_HIDEREADONLY|
	  OFN_OVERWRITEPROMPT|OFN_LONGNAMES; 
     /* openfilename.nFileOffset=NULL; */ 
     /* openfilename.nFileExtension=NULL; */
     openfilename.lpstrDefExt=def_extend; 
     /* openfilename.lCustData=NULL; */
     /* openfilename.lpfnHook=NULL; */ 
     /* openfilename.lpTemplateName=NULL; */

	 /* Possibly pressed cancel */
     if (GetSaveFileName(&openfilename)!=TRUE) break;

     if ((syxfile=fopen(init_filename,"wb"))==NULL)
	 {
      MessageBox(cz_window,"Failed to open target file!",
	   "Sorry!",MB_APPLMODAL|MB_OK);
	  break;
	 }
     receive_bank();
	 fclose(syxfile);

     break;

	case ID_CZ_03:
	 status_code=0;
	 error_code=0;
	 draw_cz_window();

	 if ((midi_device_in==0)||(midi_device_out==0))
	 {
	  MessageBox(cz_window,"Midi in or out can not be 'none'",
	   "Select legitimate Midi devices please!",
	   MB_APPLMODAL|MB_OK);
	  break;
	 }

     if (cz_test_online()!=1) break;

	 memset(&openfilename,0,sizeof(OPENFILENAME));
	 openfilename.lStructSize=sizeof(OPENFILENAME);
	 openfilename.hwndOwner=cz_window; 
     openfilename.hInstance=application_inst; 
     openfilename.lpstrFilter=file_filter; 
     /* openfilename.lpstrCustomFilter=NULL; */
     /* openfilename.nMaxCustFilter=NULL; */
     openfilename.nFilterIndex=1; 
     openfilename.lpstrFile=init_filename;
     openfilename.nMaxFile=sizeof(init_filename); 
     /* openfilename.lpstrFileTitle=NULL; */ 
     /* openfilename.nMaxFileTitle=NULL; */ 
     /* openfilename.lpstrInitialDir=NULL; */
     /* openfilename.lpstrTitle=NULL; */
     openfilename.Flags=OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		 |OFN_LONGNAMES; 
     /* openfilename.nFileOffset=NULL; */ 
     /* openfilename.nFileExtension=NULL; */
     openfilename.lpstrDefExt=def_extend; 
     /* openfilename.lCustData=NULL; */
     /* openfilename.lpfnHook=NULL; */ 
     /* openfilename.lpTemplateName=NULL; */
    
	 /* Possibly pressed cancel */
     if (GetOpenFileName(&openfilename)!=TRUE) break;

     if ((syxfile=fopen(init_filename,"rb"))==NULL)
	 {
      MessageBox(cz_window,"Failed to open source file!",
	   "Sorry!",MB_APPLMODAL|MB_OK);   
	  break;
	 }
     send_bank();
	 fclose(syxfile);

     break;

    case ID_CZ_04:
	 status_code=0;
	 error_code=0;
	 draw_cz_window();

	 if ((midi_device_in==0)||(midi_device_out==0))
	 {
	  MessageBox(cz_window,"Midi in or out can not be 'none'",
	   "Select legitimate Midi devices please!",
	   MB_APPLMODAL|MB_OK);
	  break;
	 }

     if (cz_test_online()!=1) break;

	 memset(&openfilename,0,sizeof(OPENFILENAME));
	 openfilename.lStructSize=sizeof(OPENFILENAME);
	 openfilename.hwndOwner=cz_window; 
     openfilename.hInstance=application_inst; 
     openfilename.lpstrFilter=file_filter; 
     /* openfilename.lpstrCustomFilter=NULL; */
     /* openfilename.nMaxCustFilter=NULL; */
     openfilename.nFilterIndex=1; 
     openfilename.lpstrFile=init_filename;
     openfilename.nMaxFile=sizeof(init_filename); 
     /* openfilename.lpstrFileTitle=NULL; */ 
     /* openfilename.nMaxFileTitle=NULL; */
     /* openfilename.lpstrInitialDir=NULL; */
     /* openfilename.lpstrTitle=NULL; */
     openfilename.Flags=OFN_FILEMUSTEXIST|OFN_HIDEREADONLY
		 |OFN_LONGNAMES; 
     /* openfilename.nFileOffset=NULL; */ 
     /* openfilename.nFileExtension=NULL; */
     openfilename.lpstrDefExt=def_extend; 
     /* openfilename.lCustData=NULL; */
     /* openfilename.lpfnHook=NULL; */ 
     /* openfilename.lpTemplateName=NULL; */
     
	 /* Possibly pressed cancel */
     if (GetOpenFileName(&openfilename)!=TRUE) break;

     if ((syxfile=fopen(init_filename,"rb"))==NULL)
	 {
      MessageBox(cz_window,"Failed to open source file!",
	   "Sorry!",MB_APPLMODAL|MB_OK);   
	  break;
	 }

     /* Supposed to not go on till returning */

     DialogBox(application_inst,"CZ_PATCH",cz_window,
      (DLGPROC)cz_proc_d);

     patch_single_send=1;
     send_bank();
	 fclose(syxfile);
     patch_single_send=0;
     break;

    case ID_CZ_05:
     DialogBox(application_inst,"CZ_ABOUT_DIALOG",cz_window,
      (DLGPROC)cz_proc_b); 
    break;

	case ID_CZ_06:
    ShellExecute(cz_window,"open","czlib.txt",NULL,
	  base_startup,SW_SHOWDEFAULT);
    break;

   }
   
  default:
   return(DefWindowProc(hWnd, messg, wParam, lParam));
 }
 return(0);
}

LRESULT CALLBACK cz_proc_b (HWND hWnd,UINT messg,WPARAM wParam,
 LPARAM lParam)
{

 HDC hdc;
 HDC hmdc;
 BITMAP bm;

 switch (messg) {
  case WM_DESTROY:
   break;

  case WM_INITDIALOG:
   break;

  case WM_PAINT:
   hdc=GetDC(hWnd);
   hmdc=CreateCompatibleDC(hdc);
   SelectObject(hmdc, cz_about_bmp);
   GetObject(cz_about_bmp, sizeof(bm), (LPSTR) &bm);
   BitBlt(hdc, 0, 0, bm.bmWidth, bm.bmHeight,
    hmdc, 0, 0, SRCCOPY);
   DeleteDC(hmdc);
   ReleaseDC(hWnd,hdc);
   /* following Validates and processes
   dialog window redraws */ 
   DefWindowProc(hWnd,messg,wParam,lParam);
   break;

  case WM_CLOSE:
   EndDialog(hWnd,1);
   break;

  case WM_COMMAND:

  /* It seems that the dialog procedure must exit
  with return value 0 or problems occur */

  default:
   return(0);

  }
 return(0);
}


LRESULT CALLBACK cz_proc_c (HWND hWnd,UINT messg,WPARAM wParam,
 LPARAM lParam)
{
 
 switch (messg) 
 {
  case WM_INITDIALOG:
   midi_init_dialog(hWnd);
   break;

  case WM_DESTROY:
   break;

  case WM_PAINT:
   DefWindowProc(hWnd,messg,wParam,lParam);
   break;
 	
  case WM_CLOSE:
   EndDialog(hWnd,1);
   break;

  case WM_COMMAND:
   switch (LOWORD(wParam)) 
   {
	case MIDI_OK:
	 midi_channel_num=(SendDlgItemMessage
	  (hWnd,MIDI_CH,LB_GETCURSEL,0,0)+1);
	 cz_memory=SendDlgItemMessage
	  (hWnd,CZ_MEMORY,LB_GETCURSEL,0,0);
	 midi_device_in=SendDlgItemMessage
	  (hWnd,MIDI_IN,LB_GETCURSEL,0,0);
	 midi_device_out=SendDlgItemMessage
	  (hWnd,MIDI_OUT,LB_GETCURSEL,0,0);	 
	 EndDialog(hWnd,2);
     break;
   }

  default:
   return(0); 
 
 }
 return(0);
}

LRESULT CALLBACK cz_proc_d (HWND hWnd,UINT messg,WPARAM wParam,
 LPARAM lParam)
{

 switch (messg) 
 {
  case WM_INITDIALOG:
   patch_init_dialog(hWnd);
   break;

  case WM_DESTROY:
   break;

  case WM_PAINT:
   DefWindowProc(hWnd,messg,wParam,lParam);
   break;
 	
  case WM_CLOSE:
   EndDialog(hWnd,1);
   break;

  case WM_COMMAND:
   switch (LOWORD(wParam)) 
   {
	case PA_OK:
	 patch_disc=SendDlgItemMessage
	  (hWnd,PA_DISC,LB_GETCURSEL,0,0);
	 patch_cz=SendDlgItemMessage
	  (hWnd,PA_CZ,LB_GETCURSEL,0,0);
	 EndDialog(hWnd,2);
     break;
   }

  default:
   return(0); 
 
 }
 return(0);
}

int draw_cz_window()
{
 char string_buffer[400];
 char eval_buffer[400];
 HDC hdc;
 HGDIOBJ stockob;
 LOGFONT lf;
 HFONT hlf;
 
 /* Paint the background */

 hdc=GetDC(cz_window);
 SetMapMode(hdc,MM_TEXT);
 stockob=GetStockObject(BLACK_BRUSH);
 SelectObject(hdc,stockob);
 DeleteObject(stockob);
 stockob=GetStockObject(WHITE_PEN);
 SelectObject(hdc,stockob);
 DeleteObject(stockob);
 Rectangle(hdc,3,3,258,63);
  
 SetBkMode(hdc,TRANSPARENT);
 SetTextColor(hdc,0x00FFFFFF);
 
 memset(&lf,0,sizeof(LOGFONT));
 lf.lfHeight=22;
 lf.lfWidth=9;
 lf.lfPitchAndFamily=VARIABLE_PITCH|FF_MODERN;
 lf.lfCharSet=ANSI_CHARSET;
  
 hlf=CreateFontIndirect(&lf);
 SelectObject(hdc,hlf);
 DeleteObject(hlf);

 /* Print the Status code */
 
 if (status_code!=0)
 {
  if (status_code==1) 
  {
   LoadString(application_inst,TXT_STATUS01,string_buffer,
	sizeof(string_buffer));
   sprintf(eval_buffer,string_buffer,text_value);
   TextOut(hdc,9,10,eval_buffer,strlen(eval_buffer));
  }
 
  if (status_code==2) 
  {
   LoadString(application_inst,TXT_STATUS02,string_buffer,
	sizeof(string_buffer));
   sprintf(eval_buffer,string_buffer,text_value);
   TextOut(hdc,9,10,eval_buffer,strlen(eval_buffer));
  }

  if (status_code==3) 
  {
   LoadString(application_inst,TXT_STATUS03,string_buffer,
	sizeof(string_buffer));
   sprintf(eval_buffer,string_buffer,text_value);
   TextOut(hdc,9,10,eval_buffer,strlen(eval_buffer));
  }
 
  if (status_code==4) 
  {
   LoadString(application_inst,TXT_STATUS04,string_buffer,
	sizeof(string_buffer));
   sprintf(eval_buffer,string_buffer,text_value);
   TextOut(hdc,9,10,eval_buffer,strlen(eval_buffer));
  }
 }

  /* Print the Error code */

 if (error_code!=0)
 {
  if (error_code==1) 
  {
   LoadString(application_inst,TXT_ERROR01,string_buffer,
	sizeof(string_buffer));
   sprintf(eval_buffer,string_buffer/*,text_value*/);
   TextOut(hdc,9,37,eval_buffer,strlen(eval_buffer));
  }
 
  if (error_code==2) 
  {
   LoadString(application_inst,TXT_ERROR02,string_buffer,
	sizeof(string_buffer));
   sprintf(eval_buffer,string_buffer/*,text_value*/);
   TextOut(hdc,9,37,eval_buffer,strlen(eval_buffer));
  }

  if (error_code==3) 
  {
   LoadString(application_inst,TXT_ERROR03,string_buffer,
	sizeof(string_buffer));
   sprintf(eval_buffer,string_buffer/*,text_value*/);
   TextOut(hdc,9,37,eval_buffer,strlen(eval_buffer));
  }
 }

 ReleaseDC((HWND)hdc,hdc);
 ValidateRect(cz_window,NULL);
 return(1);
}
 

